#ifndef _H_FFE6ED1ADC1F7CC5BE55084781F45CE6_ObstacleArrayMsg_DCPS_H_
#define _H_FFE6ED1ADC1F7CC5BE55084781F45CE6_ObstacleArrayMsg_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObstacleArrayMsg_.h"


namespace costmap_converter_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObstacleArrayMsg_TypeSupportInterface;

            typedef ObstacleArrayMsg_TypeSupportInterface * ObstacleArrayMsg_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArrayMsg_TypeSupportInterface> ObstacleArrayMsg_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObstacleArrayMsg_TypeSupportInterface> ObstacleArrayMsg_TypeSupportInterface_out;


            class ObstacleArrayMsg_DataWriter;

            typedef ObstacleArrayMsg_DataWriter * ObstacleArrayMsg_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArrayMsg_DataWriter> ObstacleArrayMsg_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObstacleArrayMsg_DataWriter> ObstacleArrayMsg_DataWriter_out;


            class ObstacleArrayMsg_DataReader;

            typedef ObstacleArrayMsg_DataReader * ObstacleArrayMsg_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArrayMsg_DataReader> ObstacleArrayMsg_DataReader_var;
            typedef DDS_DCPSInterface_out < ObstacleArrayMsg_DataReader> ObstacleArrayMsg_DataReader_out;


            class ObstacleArrayMsg_DataReaderView;

            typedef ObstacleArrayMsg_DataReaderView * ObstacleArrayMsg_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArrayMsg_DataReaderView> ObstacleArrayMsg_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObstacleArrayMsg_DataReaderView> ObstacleArrayMsg_DataReaderView_out;

            struct ObstacleArrayMsg_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObstacleArrayMsg_, struct ObstacleArrayMsg_Seq_uniq_> ObstacleArrayMsg_Seq;
            typedef DDS_DCPSSequence_var < ObstacleArrayMsg_Seq> ObstacleArrayMsg_Seq_var;
            typedef DDS_DCPSSequence_out < ObstacleArrayMsg_Seq> ObstacleArrayMsg_Seq_out;

            class  ObstacleArrayMsg_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObstacleArrayMsg_TypeSupportInterface_ptr _ptr_type;
                typedef ObstacleArrayMsg_TypeSupportInterface_var _var_type;

                static ObstacleArrayMsg_TypeSupportInterface_ptr _duplicate (ObstacleArrayMsg_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArrayMsg_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArrayMsg_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObstacleArrayMsg_TypeSupportInterface () {};
                ~ObstacleArrayMsg_TypeSupportInterface () {};
            private:
                ObstacleArrayMsg_TypeSupportInterface (const ObstacleArrayMsg_TypeSupportInterface &);
                ObstacleArrayMsg_TypeSupportInterface & operator = (const ObstacleArrayMsg_TypeSupportInterface &);
            };

            class  ObstacleArrayMsg_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObstacleArrayMsg_DataWriter_ptr _ptr_type;
                typedef ObstacleArrayMsg_DataWriter_var _var_type;

                static ObstacleArrayMsg_DataWriter_ptr _duplicate (ObstacleArrayMsg_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArrayMsg_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArrayMsg_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObstacleArrayMsg_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObstacleArrayMsg_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObstacleArrayMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObstacleArrayMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleArrayMsg_& instance_data) = 0;

            protected:
                ObstacleArrayMsg_DataWriter () {};
                ~ObstacleArrayMsg_DataWriter () {};
            private:
                ObstacleArrayMsg_DataWriter (const ObstacleArrayMsg_DataWriter &);
                ObstacleArrayMsg_DataWriter & operator = (const ObstacleArrayMsg_DataWriter &);
            };

            class  ObstacleArrayMsg_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObstacleArrayMsg_DataReader_ptr _ptr_type;
                typedef ObstacleArrayMsg_DataReader_var _var_type;

                static ObstacleArrayMsg_DataReader_ptr _duplicate (ObstacleArrayMsg_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArrayMsg_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArrayMsg_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleArrayMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleArrayMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleArrayMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleArrayMsg_& instance) = 0;

            protected:
                ObstacleArrayMsg_DataReader () {};
                ~ObstacleArrayMsg_DataReader () {};
            private:
                ObstacleArrayMsg_DataReader (const ObstacleArrayMsg_DataReader &);
                ObstacleArrayMsg_DataReader & operator = (const ObstacleArrayMsg_DataReader &);
            };

            class  ObstacleArrayMsg_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObstacleArrayMsg_DataReaderView_ptr _ptr_type;
                typedef ObstacleArrayMsg_DataReaderView_var _var_type;

                static ObstacleArrayMsg_DataReaderView_ptr _duplicate (ObstacleArrayMsg_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArrayMsg_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArrayMsg_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArrayMsg_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleArrayMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleArrayMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleArrayMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleArrayMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleArrayMsg_& instance) = 0;

            protected:
                ObstacleArrayMsg_DataReaderView () {};
                ~ObstacleArrayMsg_DataReaderView () {};
            private:
                ObstacleArrayMsg_DataReaderView (const ObstacleArrayMsg_DataReaderView &);
                ObstacleArrayMsg_DataReaderView & operator = (const ObstacleArrayMsg_DataReaderView &);
            };
        }

    }

}

#endif
