#ifndef _H_409AFF8CBFC89781125A18ED885E54A8_ObstacleMsg__H_
#define _H_409AFF8CBFC89781125A18ED885E54A8_ObstacleMsg__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "geometry_msgs/msg/dds_opensplice/Polygon_.h"
#include "geometry_msgs/msg/dds_opensplice/Quaternion_.h"
#include "geometry_msgs/msg/dds_opensplice/TwistWithCovariance_.h"


namespace costmap_converter_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  ObstacleMsg_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::geometry_msgs::msg::dds_::Polygon_ polygon_;
                ::DDS::Double radius_;
                ::DDS::LongLong id_;
                ::geometry_msgs::msg::dds_::Quaternion_ orientation_;
                ::geometry_msgs::msg::dds_::TwistWithCovariance_ velocities_;
            };

            typedef DDS_DCPSStruct_var<ObstacleMsg_> ObstacleMsg__var;
            typedef DDS_DCPSStruct_out < ObstacleMsg_> ObstacleMsg__out;

        }

    }

}

#endif /* _H_409AFF8CBFC89781125A18ED885E54A8_ObstacleMsg__H_ */
