#ifndef _H_409AFF8CBFC89781125A18ED885E54A8_ObstacleMsg_DCPS_H_
#define _H_409AFF8CBFC89781125A18ED885E54A8_ObstacleMsg_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObstacleMsg_.h"


namespace costmap_converter_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObstacleMsg_TypeSupportInterface;

            typedef ObstacleMsg_TypeSupportInterface * ObstacleMsg_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObstacleMsg_TypeSupportInterface> ObstacleMsg_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObstacleMsg_TypeSupportInterface> ObstacleMsg_TypeSupportInterface_out;


            class ObstacleMsg_DataWriter;

            typedef ObstacleMsg_DataWriter * ObstacleMsg_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObstacleMsg_DataWriter> ObstacleMsg_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObstacleMsg_DataWriter> ObstacleMsg_DataWriter_out;


            class ObstacleMsg_DataReader;

            typedef ObstacleMsg_DataReader * ObstacleMsg_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObstacleMsg_DataReader> ObstacleMsg_DataReader_var;
            typedef DDS_DCPSInterface_out < ObstacleMsg_DataReader> ObstacleMsg_DataReader_out;


            class ObstacleMsg_DataReaderView;

            typedef ObstacleMsg_DataReaderView * ObstacleMsg_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObstacleMsg_DataReaderView> ObstacleMsg_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObstacleMsg_DataReaderView> ObstacleMsg_DataReaderView_out;

            struct ObstacleMsg_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObstacleMsg_, struct ObstacleMsg_Seq_uniq_> ObstacleMsg_Seq;
            typedef DDS_DCPSSequence_var < ObstacleMsg_Seq> ObstacleMsg_Seq_var;
            typedef DDS_DCPSSequence_out < ObstacleMsg_Seq> ObstacleMsg_Seq_out;

            class  ObstacleMsg_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObstacleMsg_TypeSupportInterface_ptr _ptr_type;
                typedef ObstacleMsg_TypeSupportInterface_var _var_type;

                static ObstacleMsg_TypeSupportInterface_ptr _duplicate (ObstacleMsg_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleMsg_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleMsg_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleMsg_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleMsg_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObstacleMsg_TypeSupportInterface () {};
                ~ObstacleMsg_TypeSupportInterface () {};
            private:
                ObstacleMsg_TypeSupportInterface (const ObstacleMsg_TypeSupportInterface &);
                ObstacleMsg_TypeSupportInterface & operator = (const ObstacleMsg_TypeSupportInterface &);
            };

            class  ObstacleMsg_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObstacleMsg_DataWriter_ptr _ptr_type;
                typedef ObstacleMsg_DataWriter_var _var_type;

                static ObstacleMsg_DataWriter_ptr _duplicate (ObstacleMsg_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleMsg_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleMsg_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleMsg_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleMsg_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObstacleMsg_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObstacleMsg_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObstacleMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObstacleMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObstacleMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObstacleMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObstacleMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObstacleMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObstacleMsg_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObstacleMsg_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObstacleMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleMsg_& instance_data) = 0;

            protected:
                ObstacleMsg_DataWriter () {};
                ~ObstacleMsg_DataWriter () {};
            private:
                ObstacleMsg_DataWriter (const ObstacleMsg_DataWriter &);
                ObstacleMsg_DataWriter & operator = (const ObstacleMsg_DataWriter &);
            };

            class  ObstacleMsg_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObstacleMsg_DataReader_ptr _ptr_type;
                typedef ObstacleMsg_DataReader_var _var_type;

                static ObstacleMsg_DataReader_ptr _duplicate (ObstacleMsg_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleMsg_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleMsg_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleMsg_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleMsg_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleMsg_& instance) = 0;

            protected:
                ObstacleMsg_DataReader () {};
                ~ObstacleMsg_DataReader () {};
            private:
                ObstacleMsg_DataReader (const ObstacleMsg_DataReader &);
                ObstacleMsg_DataReader & operator = (const ObstacleMsg_DataReader &);
            };

            class  ObstacleMsg_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObstacleMsg_DataReaderView_ptr _ptr_type;
                typedef ObstacleMsg_DataReaderView_var _var_type;

                static ObstacleMsg_DataReaderView_ptr _duplicate (ObstacleMsg_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleMsg_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleMsg_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleMsg_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleMsg_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleMsg_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleMsg_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleMsg_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleMsg_& instance) = 0;

            protected:
                ObstacleMsg_DataReaderView () {};
                ~ObstacleMsg_DataReaderView () {};
            private:
                ObstacleMsg_DataReaderView (const ObstacleMsg_DataReaderView &);
                ObstacleMsg_DataReaderView & operator = (const ObstacleMsg_DataReaderView &);
            };
        }

    }

}

#endif
